(function(){
	'use strict';
	var myApp =angular.module('myApp', []);
        myApp.config(function($httpProvider) {
    $httpProvider.defaults.headers.put['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8';
    $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8';
    // Override $http service's default transformRequest
    $httpProvider.defaults.transformRequest = [function(data) {
        /**
         * The workhorse; converts an object to x-www-form-urlencoded serialization.
         * @param {Object} obj
         * @return {String}
         */
        var param = function(obj) {
            var query = '';
            var name, value, fullSubName, subName, subValue, innerObj, i;
            for (name in obj) {
                value = obj[name];
                if (value instanceof Array) {
                    for (i = 0; i < value.length; ++i) {
                        subValue = value[i];
                        fullSubName = name + '[' + i + ']';
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + '&';
                    }
                } else if (value instanceof Object) {
                    for (subName in value) {
                        subValue = value[subName];
                        fullSubName = name + '[' + subName + ']';
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + '&';
                    }
                } else if (value !== undefined && value !== null) {
                    query += encodeURIComponent(name) + '='
                            + encodeURIComponent(value) + '&';
                }
            }
            return query.length ? query.substr(0, query.length - 1) : query;
        };
        return angular.isObject(data) && String(data) !== '[object File]'
                ? param(data)
                : data;
    }];
});
})();
// JSONP
function getParam(name) {
    return location.href.match(new RegExp('[?&]' + name + '=([^?&]+)', 'i')) ? decodeURIComponent(RegExp.$1) : '';
}
function BreandownCtrl($scope, $http) {
    $scope.product_id = getParam('product_id');
    $scope.product_name = getParam('product_name');
    $scope.cate_id = getParam('cate_id');
    $scope.cate_name = getParam('cate_name');
    $scope.brand_id = getParam('brand_id');
    $http.get("http://clear.jdguanjia.com/hac/getFormatName?channelCode="+localStorage.getItem('channelAppid')+"&businessId=2&categoryId="+$scope.cate_id+"&brandId="+$scope.brand_id+"&modelId="+$scope.product_id).success(function(data) {
        $scope.infoColors = data[0].body;
        setTimeout(function() {
            $('.breakdown-color li').click(function() {
                $('.breakdown-color li').removeClass('breakdown-selected');
                $(this).addClass('breakdown-selected');
            })
        },1)
    });
    $http.get("http://clear.jdguanjia.com/hac/getHitchId?channelCode="+localStorage.getItem('channelAppid')+"&businessId=2&categoryId="+$scope.cate_id+"&brandId="+$scope.brand_id+"&modelId="+$scope.product_id).success(function(data) {
        $scope.hitchs = data[0].body;
        setTimeout(function() {
            var optionLen = $('.breakdown-option li').length;
            var optionHei = 0;
            for (var i = 0; i < $('.breakdown-option li').length; i++) {
                optionHei = $('.breakdown-option li').eq(i).height();
                if(optionHei == 21) {
                    $('.breakdown-option li').eq(i).css({
                        'height': 42 + 'px',
                        'line-height': 42 + 'px'
                    })
                }
            };
            $('.breakdown-option li').click(function() {
                $('.breakdown-option li').removeClass('breakdown-selected');
                $(this).addClass('breakdown-selected');
                $('.breakdown-detail').removeClass('hidden');
            })
        },1)
    });
    $scope.getColorId = function(infoColor) {
        $scope.color_id = infoColor.id;
        $scope.color_name = infoColor.name;
    }
    $scope.getDetail = function(hitch) {
        $scope.subHitchs = hitch.childHichList;
    }
    $scope.getHitchId = function(subHitch) {
        $scope.hitch_id = subHitch.id;
        $scope.hitch_name = subHitch.hitchName;
    }
    $scope.getHei = function() {
        setTimeout(function() {
            var detailLen = $('.breakdown-detail li').length;
            var detailHei = 0;
            for (var i = 0; i < $('.breakdown-detail li').length; i++) {
                detailHei = $('.breakdown-detail li').eq(i).height();
                if(detailHei == 21) {
                    $('.breakdown-detail li').eq(i).css({
                        'height': 42 + 'px',
                        'line-height': 42 + 'px'
                    })
                }
            };
            $('.breakdown-detail li').click(function() {
                $('.breakdown-detail li').removeClass('breakdown-selected');
                $(this).addClass('breakdown-selected');
            })
        },1)
    }
    $scope.linkTo = function() {
        if(!$('.breakdown-color li').hasClass('breakdown-selected')) {
            alert('请选择颜色');
        } else if(!$('.breakdown-option li').hasClass('breakdown-selected')) {
            alert('请选择故障分类');
        } else if(!$('.breakdown-detail li').hasClass('breakdown-selected')) {
            alert('请选择详细故障');
        } else {
            location.href = "frame-repair-price.html?cate_id="+$scope.cate_id+"&brand_id="+$scope.brand_id+"&product_id="+$scope.product_id+"&product_name="+$scope.product_name+"&cate_name="+$scope.cate_name+"&color_id="+$scope.color_id+"&color_name="+$scope.color_name+"&hitch_id="+$scope.hitch_id+"&hitch_name="+$scope.hitch_name;
        }
    }
}