(function(){
    'use strict';
    var myApp =angular.module('myApp', []);
        myApp.config(function($httpProvider) {
    $httpProvider.defaults.headers.put['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8';
    $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8';
    // Override $http service's default transformRequest
    $httpProvider.defaults.transformRequest = [function(data) {
        /**
         * The workhorse; converts an object to x-www-form-urlencoded serialization.
         * @param {Object} obj
         * @return {String}
         */
        var param = function(obj) {
            var query = '';
            var name, value, fullSubName, subName, subValue, innerObj, i;
            for (name in obj) {
                value = obj[name];
                if (value instanceof Array) {
                    for (i = 0; i < value.length; ++i) {
                        subValue = value[i];
                        fullSubName = name + '[' + i + ']';
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + '&';
                    }
                } else if (value instanceof Object) {
                    for (subName in value) {
                        subValue = value[subName];
                        fullSubName = name + '[' + subName + ']';
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + '&';
                    }
                } else if (value !== undefined && value !== null) {
                    query += encodeURIComponent(name) + '='
                            + encodeURIComponent(value) + '&';
                }
            }
            return query.length ? query.substr(0, query.length - 1) : query;
        };
        return angular.isObject(data) && String(data) !== '[object File]'
                ? param(data)
                : data;
    }];
});
})();
// JSONP
function getParam(name) {
    return location.href.match(new RegExp('[?&]' + name + '=([^?&]+)', 'i')) ? decodeURIComponent(RegExp.$1) : '';
}
function UserCtrl($scope, $http) {
    // 定位接口
    var onSuccess = function(position) {
        addrUrl = "http://www.jdguanjia.com/app/api_address.php?callback=JSON_CALLBACK&loc="+position.coords.longitude +","+position.coords.latitude;
        $http.jsonp(addrUrl).success(function(data) {
            $scope.user_address = data.result.formatted_address;
            $scope.address = data.result.formatted_address;
        });
    };
    function onError(error) {
        
    }
    navigator.geolocation.getCurrentPosition(onSuccess, onError);
    
    $scope.cate_id = getParam('cate_id');
    $scope.brand_id = getParam('brand_id');
    $scope.productId = getParam('productId');
    $scope.formatId = getParam('formatId');
    $scope.price = getParam('price');
    $scope.fee = getParam('fee');
    var rep = 0;
    // 服务城市
    $scope.cityList = function() {
        $http.get("http://clear.jdguanjia.com/hac/getCitys?businessId=5&channelCode="+localStorage.getItem('channelAppid')+"&regionId=0&regionLevel=2").success(function(data) {
            $scope.citys = data.body;
        });
        $('.quyu').hide();
        $('#slectCity').show();
    }
    $scope.selCity = function(target,city) {
        $('#slectCity').hide();
        $('.quyu').show();
        $('#user-city').val(target.innerHTML);
        $scope.selectEdCityID = target.innerHTML;
        $scope.orderCity = city.cityCode;
        $scope.districts = '';
        $('#user-quyu').val('');
    }
    // 服务区域
    $scope.quyuList = function() {
        $http.get("http://clear.jdguanjia.com/hac/getCityArea?businessId=5&channelCode="+localStorage.getItem('channelAppid')+"&cityId="+$scope.orderCity).success(function(data) {
            $scope.districts = data;
        });
        var userselcity = $('#user-city').val();
        if(userselcity){
            $('.quyu').hide();
            $('#selectQuyu').show();
        }
    }
    $scope.selQuyu = function(target,district) {
        $('#selectQuyu').hide();
        $('.quyu').show();
        $('#user-quyu').val(target.innerHTML);
        $scope.district_id = district.id;
    }
    // 预约日期
    $scope.userSelect = function() { 
        $.ajax({
            type: "GET", //用POST方式传输
            dataType: "text", //数据格式:JSON
            url: 'http://m.jdguanjia.com/_wx/citytask?cityid='+$scope.selectEdCityID, //目标地址
            error: function (XMLHttpRequest, textStatus, errorThrown) {},
            success: function (msg){
                var dateObj = JSON.parse(msg);
                var dateStr = '';
                for(var i=0;i<30;i++){ 
                    if(dateObj[i]['status'] == 1){ 
                        dateStr += '<font class="rl-col" value="'+dateObj[i]['odate']+'">'+dateObj[i]['date']+'</font>';
                    }else{ 
                        dateStr += '<font>'+dateObj[i]['date']+'</font>';
                    }
                }
                $('.wap-rl-per').html(dateStr);
                $('.wap-rl-box .rl-col').click(function() { 
                    var userrili= $(this).attr('value');
                    $('#userdate').val(userrili);
                    $('.wap-rl-box').hide();
                })
                
            }
        });
    }
    // 提交订单
    $scope.submitOrder = function(username,phone,address,address2,coment) {
        if(address2 == undefined) {
            address2 = '';
        }
        if(coment == undefined) {
            coment = '';
        }
        //验证表单
        var usernameReg = /^[\u4E00-\u9FA5\uf900-\ufa2d]{1,10}$/;
        var phoneReg = /^1[0-9]\d{9}$/;
        var addressReg = /^.{1,50}$/;
        var business = localStorage.getItem('business');
        if(username == undefined) {
            $('#errormess').text('*请输入您的姓名');
        } else if(!usernameReg.test(username)) {
            $('#errormess').text('*姓名不正确');
        } else if(phone == undefined) {
            $('#errormess').text('*请输入您的常用手机号');
        } else if(!phoneReg.test(phone)) {
            $('#errormess').text('*手机号格式不正确');
        } else if($('#user-city').val() == '') {
            $('#errormess').text('请选择服务城市');
        } else if($('#user-quyu').val() == '') {
            $('#errormess').text('请选择服务区域');
        } else if($('#userdate').val() == '') {
            $('#errormess').text('请选择预约日期');
        } else if($('#usersxw').val() == '') {
            $('#errormess').text('请选择预约时间');
        } else if(address == undefined) {
            $('#errormess').text('*请输入您的地址');
        } else if(!addressReg.test(address)) {
            $('#errormess').text('*地址不正确');
        } else {
            if(rep==1){
                return false;
            }
            rep = 1;
            $('#errormess').text('');
            var data = {"orderName": ""+username+"", "orderPhone": ""+phone+"", "orderAddress": ""+$('#user-city').val()+$('#user-quyu').val()+address+address2+"", "orderComment": ""+coment+"", "businessId": "5", "channelCode": ""+localStorage.getItem('channelAppid')+"", "subscribe": ""+$('.tv-user-date').val()+' '+$('.tv-user-day').val()+"", "orderCity": ""+$scope.district_id+"", "orders": [{"productId": ""+$scope.productId+"", "productNum": "1"}], "formatId": ""+$scope.formatId+"", "price": ""+$scope.price+"", "fee": ""+$scope.fee+"", "specialOffer": "0", "couponCode": "0"};
            $http.post(
                "http://c.jdguanjia.com/api/newSubmitOrder",{
                "data": JSON.stringify(data),
                "appKey": localStorage.getItem('channelAppid'),
                "methodName": 'newSubmitOrder',
                "timestamp": Date.parse(new Date()),
                "version": 1.0,
                "token": ''
            }).success(function(data) {
                if(data.code == 0){
                    location.href = "frame-tiemo-success.html?order_no="+data.body.orderNo+"&orderCity="+$scope.orderCity+"&district_id="+$scope.district_id;
                } else {
                    rep = 0;
                    // alert('数据传输失败，请重试');
                    alert(data.msg);
                }
            });
        }
    }
}