(function(){
	'use strict';
	var myApp =angular.module('myApp', []);
        myApp.config(function($httpProvider) {
    $httpProvider.defaults.headers.put['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8';
    $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8';
    // Override $http service's default transformRequest
    $httpProvider.defaults.transformRequest = [function(data) {
        /**
         * The workhorse; converts an object to x-www-form-urlencoded serialization.
         * @param {Object} obj
         * @return {String}
         */
        var param = function(obj) {
            var query = '';
            var name, value, fullSubName, subName, subValue, innerObj, i;
            for (name in obj) {
                value = obj[name];
                if (value instanceof Array) {
                    for (i = 0; i < value.length; ++i) {
                        subValue = value[i];
                        fullSubName = name + '[' + i + ']';
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + '&';
                    }
                } else if (value instanceof Object) {
                    for (subName in value) {
                        subValue = value[subName];
                        fullSubName = name + '[' + subName + ']';
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        query += param(innerObj) + '&';
                    }
                } else if (value !== undefined && value !== null) {
                    query += encodeURIComponent(name) + '='
                            + encodeURIComponent(value) + '&';
                }
            }
            return query.length ? query.substr(0, query.length - 1) : query;
        };
        return angular.isObject(data) && String(data) !== '[object File]'
                ? param(data)
                : data;
    }];
});
})();
// JSONP
function getParams(name) {
    return location.href.match(new RegExp('[?&]' + name + '=([^?&]+)', 'i')) ? decodeURIComponent(RegExp.$1) : '';
}
var colorId = 0;
var memoryId = 0;
var wayId = 0;
var netId = 0;
var baoId = 0;

var cata_id = localStorage.getItem('categoryId');
var brand_id = localStorage.getItem('brandId');
var modid = localStorage.getItem('modelId');
var needRegNet = 0;
var needRegZbao = 0;
var channelAppid = localStorage.getItem('channelAppid');
function phoneCtrl($scope, $http) {
    recycleUrl = "http://clear.jdguanjia.com/hac/getFormatName?channelCode="+channelAppid+"&businessId=1&categoryId="+cata_id+"&brandId="+brand_id+"&modelId="+modid;
    $http.get(recycleUrl).success(function(data){
        $scope.sellInfos = data.body;
        var dataBody = data[0].body;
        for(var i=0;i<dataBody.length;i++){
            if(dataBody[i].formatClassName == '颜色'){ 
                $scope.sellColors = dataBody[i].formatList;
                $('.g1').show();
            }else if(dataBody[i].formatClassName == '内存'){ 
                $scope.sellMemorys = dataBody[i].formatList;
                $('.g2').show();
            }else if(dataBody[i].formatClassName == '渠道'){ 
                $scope.sellWays = dataBody[i].formatList;
                $('.g3').show();
            }else if(dataBody[i].formatClassName == '网络制式'){ 
                $scope.sellNets = dataBody[i].formatList;
                $('.g4').show();
                needRegNet = 1;
            }else if(dataBody[i].formatClassName == '是否在保'){ 
                $scope.sellBaos = dataBody[i].formatList;
                $('.g5').show();
                needRegZbao = 1;
            }
        }
    });

    // 回收型号
    $scope.getType = function(brand,sellData) {
        if(!colorId){
            alert('请选择颜色');
            return;
        }
        if(!memoryId){
            alert('请选择内存');
            return;
        }
        if(!wayId){
            alert('请选择渠道');
            return;
        }
        if(needRegNet && !netId){
            alert('请选择网络制式');
            return;
        }
        if(needRegZbao && !baoId){
            alert('请选择是否再保');
            return;
        }
        
        var nexusFormatIds = colorId+","+memoryId+","+wayId;
        if(needRegNet&&netId!=0){
            nexusFormatIds+=","+netId;
        }
        if(needRegZbao&& baoId!=0){
            nexusFormatIds+=","+baoId;
        }
        
        localStorage.setItem('nexusFormatIds', nexusFormatIds);
        location.href = "sell_detail.html?nexusFormatIds="+nexusFormatIds;
    }
}

function colorChang(that){
    $('.broken-color li').removeClass('broken-selected');
    $(that).addClass('broken-selected');
    colorId = $(that).attr('idval');
    localStorage.setItem('colorName',$(that).find('a').text());
}

function memoryChang(that){
    $('.broken-option li').removeClass('broken-selected');
    $(that).addClass('broken-selected');
    memoryId = $(that).attr('idval');
    localStorage.setItem('memoryName',$(that).find('a').text());
}

function wayChang(that){
    $('.broken-detail li').removeClass('broken-selected');
    $(that).addClass('broken-selected');
    wayId = $(that).attr('idval');
    localStorage.setItem('wayName',$(that).find('a').text());
}

function netChang(that){
    $('.broken-net li').removeClass('broken-selected');
    $(that).addClass('broken-selected');
    netId = $(that).attr('idval');
    localStorage.setItem('netName',$(that).find('a').text());
}

function baoChang(that){
    $('.broken-bao li').removeClass('broken-selected');
    $(that).addClass('broken-selected');
    baoId = $(that).attr('idval');
    localStorage.setItem('baoName',$(that).find('a').text());
}
